﻿Option Explicit Off
Option Strict Off

Imports Game_PluginAPI
Imports System.Xml.Serialization
Imports System.Xml
Imports System.IO
Imports System.Linq
Imports System.Net.Sockets
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.Net


Public Class GamePlugin
    Implements IPlugin_Game
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                            SimTools Plugin - Edit the Setting below to provide support for your favorite game!                             ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////// 
    '/// Per Game Settings - Change for Each Game ///
    '////////////////////////////////////////////////
    Private Const _PluginAuthorsName As String = "Ville Pesonen"
    Private Const _GameName As String = "War Thunder" 'GameName (Must Be Unique!) - the displayed Name.
    Private Const _ProcessName As String = "aces" 'Process_Name without the (".exe") for this game
    Private Const _Port As String = "4123"  'Your Sending/Recieving UDP Port for this game
    Private Const _RequiresPatchingPath As Boolean = False 'do we need the game exe path for patching? (must be True if _RequiresSecondCheck = True)
    Private Const _RequiresSecondCheck As Boolean = False 'Used when games have the same _ProcessName. (all plugins with the same _ProcessName must use this!)
    Private Const _PluginOptions As String = "" 'Reserved For Future Use - No Change Needed 
    '////////////////////////////////////////////////
    '///           Memory Map Variables           ///
    '////////////////////////////////////////////////
    Private Const _Enable_MemoryMap As Boolean = False 'Is a MemoryMap file Required for this game?
    Private Const _MMF_Name As String = "" 'Set if using a Memory Map File - EXAMPLE("$gtr2$")
    '////////////////////////////////////////////////
    '///           MemoryHook Variables           ///
    '////////////////////////////////////////////////   
    Private Const _Enable_MemoryHook As Boolean = True 'Is a Memory Hook Required for this game? 
    Private Const _MemHook_Roll As UInteger = &H1234567 'Not Used = 0
    Private Const _MemHook_Pitch As UInteger = &H1234567 'Not Used = 0
    Private Const _MemHook_Heave As UInteger = &H1234567
    Private Const _MemHook_Yaw As UInteger = &H1234567 'Not Used = 0
    Private Const _MemHook_Sway As UInteger = &H1234567
    Private Const _MemHook_Surge As UInteger = &H1234567
    Private Const _MemHook_Extra1 As UInteger = &H1234567 'Not Used = 0
    Private Const _MemHook_Extra2 As UInteger = &H1234567 'Not Used = 0
    Private Const _MemHook_Extra3 As UInteger = &H1234567 'Not Used = 0
    '////////////////////////////////////////////////
    '///    DOFs Used for Output for this Game    ///
    '////////////////////////////////////////////////
    Private Const _DOF_Support_Roll As Boolean = True
    Private Const _DOF_Support_Pitch As Boolean = True
    Private Const _DOF_Support_Heave As Boolean = True
    Private Const _DOF_Support_Yaw As Boolean = True
    Private Const _DOF_Support_Sway As Boolean = True
    Private Const _DOF_Support_Surge As Boolean = True
    Private Const _DOF_Support_Extra1 As String = "Roll Deg / s" 'Blank = False
    Private Const _DOF_Support_Extra2 As String = "Pitch: Elevator position" '"" = Not Used
    Private Const _DOF_Support_Extra3 As String = "Rudder position" 'ADD THE FORCE NAME HERE
    '/////////////////////////////////////////////////
    '///       GameDash - Dash Board Support       ///
    '/////////////////////////////////////////////////
    Private Const _Enable_DashBoard As Boolean = True  'Enable the DashBoard Output System?
    'EXAMPLES OF DASH OUTPUT (all variables are strings) - 20 DASH OUTPUTS MAX!!!
    'Use the Variables with either Process_PacketRecieved, Process_MemoryHook or Process_MemoryMap.
    'Variable = (*Action, Value) as String - (The *Action variable can be anything)
    'Basic Dash Support should include at the minimum -  SPEED, RPM and GEAR
    'Dash_1_Output = "Speed," & OUTPUT_VALUE_HERE.ToString
    'Dash_2_Output = "Rpm," & OUTPUT_VALUE_HERE.ToString
    'Dash_2_Output = "Gear," & OUTPUT_VALUE_HERE.ToString
    '...
    'Dash_20_Output = "Engine Temp," & OUTPUT_VALUE_HERE.ToString
    '/////////////////////////////////////////////////
    '///           GameVibe Support              ///
    '/////////////////////////////////////////////////
    Private Const _Enable_GameVibe As Boolean = True 'Enable the GameVibe Output System?
    'EXAMPLES OF GameVibe OUTPUT (all variables are strings) - 9 GameVibe OUTPUTS MAX!!!
    'Use the Variables with either Process_PacketRecieved, Process_MemoryHook or Process_MemoryMap.
    'Variable = (*Action, Value) as String - (The *Action" variable can ONLY be: Rpm, Heave, Sway, Surge, FR, FL, RR, RL, Turbo)
    'Basic GameVibe Support should include at the minimum -  Rpm
    'Vibe_1_Output = "Rpm," & OUTPUT_VALUE_HERE.ToString
    'Vibe_2_Output = "Heave," & OUTPUT_VALUE_HERE.ToString
    'Vibe_3_Output = "Sway," & OUTPUT_VALUE_HERE.ToString
    'Vibe_4_Output = "Surge," & OUTPUT_VALUE_HERE.ToString
    '...
    'Vibe_9_Output = "Gear Shift," & OUTPUT_VALUE_HERE.ToString
    '/////////////////////////////////////////////////

    'Used by GameManager when the Game Starts.
    Dim BaseAddress As Int32

    Dim ux, uy, uz, fx, fy, fz, rx, ry, rz As Single
    Dim ax, ay, az As Single
    Dim p As Process

    'Tuning variables
    Dim flapsmultiplier As Double = 0.1
    Dim landinggearmultiplier As Double = 0.2

    'Variables for the War Thunder plugin'
    Dim parser() As String
    Dim bparser() As String
    Dim TAS As Double
    Dim Ny As Double
    Dim Wx As Double
    Dim Speed As Double
    Dim LSpeed As Double
    Dim Surge As Double
    Dim rpm As Double
    Dim weapon1 As Double
    Dim weapon2 As Double
    Dim altmin As Double
    Dim compass As Double
    Dim oil_pressure As Double
    Dim oil_temperature As Double
    Dim water_temperature As Double
    Dim mixture As Double
    Dim fuel1 As Double
    Dim gears As Double
    Dim flaps As Double
    Dim trimmer As Double
    Dim throttle1 As Double
    Dim prop_pitch As Double
    Dim manifold_pressure As Double
    'Dim Bank As Single
    'Dim Turn As Single
    'Dim Vario As Single
    Dim AoS As Double
    Dim Elevator As Double
    Dim Rudder As Double
    Dim aviahorizon_roll As Double
    Dim aviahorizon_pitch As Double
    Dim turn As Double
    'Dim memoryhookammocorrect As Boolean
    'Dim ammomemorylocationweapon1 As UInteger
    'Dim ammomemorylocationweapon2 As UInteger
    'Dim Counter As Integer
    'Dim lTAS As Single
    'Dim lNy As Single
    'Dim lWx As Single
    'Dim lVario As Single
    Dim trimchars As Char() = {",", "}"}
    Dim sURL As String
    Dim aURL As String


    Public Sub GameStart() Implements IPlugin_Game.GameStart
        'memoryhookammocorrect = False
        'Using reader As XmlReader = XmlReader.Create(".\pluginconfig.xml")
        'While reader.Read()
        'If reader.IsStartElement() Then
        'If reader.Name = "value" Then
        'Dim attribute As String = reader("name")
        'If attribute = "ammomemorylocationweapon1" Then
        'ammomemorylocationweapon1 = Convert.ToUInt32(reader.Value.Trim())
        'ElseIf attribute = "ammomemorylocationweapon2" Then
        'ammomemorylocationweapon2 = Convert.ToUInt32(reader.Value.Trim())
        'ElseIf attribute = "memoryhookammocorrect" Then
        'If (reader.Value.Trim() = "0") Then
        'memoryhookammocorrect = False
        'Else
        'memoryhookammocorrect = True
        'End If
        'ElseIf attribute = "flapsturbulencemultiplier" Then
        'Double.TryParse(reader.Value.Trim(), flapsmultiplier)
        'ElseIf attribute = "landinggearsturbulencemultiplier" Then
        'Double.TryParse(reader.Value.Trim(), landinggearmultiplier)
        'End If
        'End If
        'End If
        'End While
        'End Using
    End Sub

    'Used by GameManager when the Game Stops.
    Public Sub GameStop() Implements IPlugin_Game.GameEnd
        'DO SOMETHING HERE AT GAME STOP!
    End Sub

    'Used by GameManager to Process a MemoryHook.
    Public Sub Process_MemoryHook() Implements IPlugin_Game.Process_MemoryHook
        'DO SOMETHING HERE AT GAME START!  
        Try
            sURL = "http://127.0.0.1:8111/state"
            aURL = "http://127.0.0.1:8111/indicators"

            Dim wrGETURL As WebRequest
            wrGETURL = WebRequest.Create(sURL)
            Dim Response As WebResponse = wrGETURL.GetResponse()

            Dim objStream As Stream
            objStream = wrGETURL.GetResponse.GetResponseStream()

            'Dim objReader As New StreamReader(objStream, System.Text.Encoding.ASCII)
            Dim objReader As New StreamReader(objStream)

            Dim sLine As String = ""
            Dim i As Integer = 0
            'state
            Do While Not sLine Is Nothing
                i += 1
                sLine = objReader.ReadLine
                parser = Split(sLine, ": ")
                If String.Compare(parser(0), Chr(123) & " " & Chr(34) & "valid" & Chr(34)) = 0 Then
                    If String.Compare(parser(1), "false" & " " & Chr(125)) = 0 Then
                        Ny = 1
                        'TAS = 0
                        Wx = 0
                        AoS = 0
                        Elevator = 0
                        Rudder = 0
                        Speed = 0
                        LSpeed = 0
                        Surge = 0
                        aviahorizon_pitch = 0
                        aviahorizon_roll = 0
                    End If
                End If
                'If String.Compare(parser(0), Chr(34) & "TAS, km/h" & Chr(34)) = 0 Then TAS = Convert.ToSingle(parser(1).Trim(CChar(",")).Replace(".", ","))
                'If String.Compare(parser(0), Chr(34) & "Speed" & Chr(34)) = 0 Then Speed = Convert.ToSingle(parser(1).Trim(CChar(",")).Replace(".", ","))
                If String.Compare(parser(0), Chr(34) & "Ny" & Chr(34)) = 0 Then Ny = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "Wx, deg/s" & Chr(34)) = 0 Then Wx = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "AoS, deg" & Chr(34)) = 0 Then AoS = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "elevator, %" & Chr(34)) = 0 Then Elevator = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "rudder, %" & Chr(34)) = 0 Then Rudder = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "RPM 1" & Chr(34)) = 0 Then rpm = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "TAS, km/h" & Chr(34)) = 0 Then TAS = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "flaps, %" & Chr(34)) = 0 Then flaps = Convert.ToDouble(parser(1).Trim(trimchars))
                If String.Compare(parser(0), Chr(34) & "gear, %" & Chr(34)) = 0 Then gears = Convert.ToDouble(parser(1).Trim(trimchars))
            Loop
            objReader.Close()
            Response.Close()

            Dim arGETURL As WebRequest
            arGETURL = WebRequest.Create(aURL)
            Dim aresponse As WebResponse = arGETURL.GetResponse()
            Dim aobjStream As Stream
            aobjStream = arGETURL.GetResponse.GetResponseStream()


            Dim aobjReader As New StreamReader(aobjStream)

            Dim aLine As String = ""
            Dim a As Integer = 0
            'indicators
            Do While Not aLine Is Nothing
                a += 1
                aLine = aobjReader.ReadLine
                bparser = Split(aLine, ": ")
                ''If String.Compare(bparser(0), Chr(34) & "bank" & Chr(34)) = 0 Then Bank = Convert.ToSingle(bparser(1).Trim(CChar(",")))
                'Add the following at the end if plugin has trouble with locale: .Replace(".", ","))
                If String.Compare(bparser(0), Chr(34) & "aviahorizon_roll" & Chr(34)) = 0 Then aviahorizon_roll = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "aviahorizon_pitch" & Chr(34)) = 0 Then aviahorizon_pitch = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "speed" & Chr(34)) = 0 Then Speed = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "turn" & Chr(34)) = 0 Then turn = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "weapon1" & Chr(34)) = 0 Then weapon1 = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "weapon2" & Chr(34)) = 0 Then weapon2 = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "altitude_min" & Chr(34)) = 0 Then altmin = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "compass" & Chr(34)) = 0 Then compass = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "oil_pressure" & Chr(34)) = 0 Then oil_pressure = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "oil_temperature" & Chr(34)) = 0 Then oil_temperature = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "water_temperature" & Chr(34)) = 0 Then water_temperature = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "mixture" & Chr(34)) = 0 Then mixture = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "fuel1" & Chr(34)) = 0 Then fuel1 = Convert.ToDouble(bparser(1).Trim(trimchars))
                'If String.Compare(bparser(0), Chr(34) & "gears" & Chr(34)) = 0 Then gears = Convert.ToDouble(bparser(1).Trim(trimchars))
                'If String.Compare(bparser(0), Chr(34) & "flaps" & Chr(34)) = 0 Then flaps = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "trimmer" & Chr(34)) = 0 Then trimmer = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "throttle" & Chr(34)) = 0 Then throttle1 = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "prop_pitch" & Chr(34)) = 0 Then prop_pitch = Convert.ToDouble(bparser(1).Trim(trimchars))
                If String.Compare(bparser(0), Chr(34) & "manifold_pressure" & Chr(34)) = 0 Then manifold_pressure = Convert.ToDouble(bparser(1).Trim(trimchars))
            Loop

            aobjReader.Close()
            aresponse.Close()
            'lVario = Vario

            'Timer = moment.Millisecond
            Surge = (Speed - LSpeed) * 100
            LSpeed = Speed
            'Timer2 = Timer

            'assign motion data
            Roll_MemHook = aviahorizon_roll
            Pitch_MemHook = aviahorizon_pitch
            Heave_MemHook = Ny - 1
            Yaw_MemHook = turn
            Sway_MemHook = AoS
            Surge_MemHook = Surge
            Extra1_MemHook = Wx
            Extra2_MemHook = Elevator
            Extra3_MemHook = Rudder

            'Correct weapon fire values if memhook is correct
            'If memoryhookammocorrect = True Then
            'read memory hook values
            'Dim memoryvalue = do some magic and read the memory value
            'If memoryvalue = 0 Then
            'weapon1 = 0
            'weapon1 = 0
            'End If
            'End If

            'assign gamevibe data
            Vibe_1_Output = "Rpm," & rpm.ToString
            Vibe_2_Output = "Road Detail," & (Ny - 1).ToString
            Vibe_3_Output = "Turbulence," & (Speed + (flaps * Speed * flapsmultiplier) + (gears * Speed * landinggearmultiplier)).ToString
            Vibe_4_Output = "Collision L/R," & AoS.ToString
            Vibe_5_Output = "Collision F/B," & Surge.ToString
            Vibe_6_Output = "Weapons 1," & weapon1.ToString
            Vibe_7_Output = "Weapons 2," & weapon2.ToString
            Vibe_8_Output = "Landing Gear," & gears.ToString
            Vibe_9_Output = "Flaps," & flaps.ToString

            'assign gamedash data
            Dash_1_Output = "gears," & gears.ToString
            Dash_2_Output = "flaps," & flaps.ToString
            Dash_3_Output = "trimmer," & trimmer.ToString
            Dash_4_Output = "throttle," & throttle1.ToString
            Dash_5_Output = "prop_pitch," & prop_pitch.ToString
            Dash_6_Output = "manifold_pressure," & manifold_pressure.ToString
            Dash_7_Output = "RPM," & rpm.ToString
            Dash_8_Output = "altitude_min," & altmin.ToString
            Dash_9_Output = "compass," & compass.ToString
            Dash_10_Output = "oil_pressure," & oil_pressure.ToString
            Dash_11_Output = "oil_temperature," & oil_temperature.ToString
            Dash_12_Output = "water_temperature," & water_temperature.ToString
            Dash_13_Output = "mixture," & mixture.ToString
            Dash_14_Output = "fuel1," & fuel1.ToString
            Dash_15_Output = "weapon1," & weapon1.ToString
            Dash_16_Output = "weapon2," & weapon2.ToString
            Dash_17_Output = "aviahorizon_roll," & aviahorizon_roll.ToString
            Dash_18_Output = "aviahorizon_pitch," & aviahorizon_pitch.ToString
            Dash_19_Output = "AoS deg," & AoS.ToString
            Dash_20_Output = "TAS km/h," & TAS.ToString


        Catch ex As Exception
        End Try
    End Sub

    'Used by GameManager to Process a MemoryMap.
    Public Sub Process_MemoryMap() Implements IPlugin_Game.Process_MemoryMap
        'DO SOMETHING HERE AT GAME START! 
    End Sub

    'Used by GameEngine to Process Incoming UDP Packets.
    Private Input_Data As New GenericOutput
    Public Sub Process_PacketRecieved(Text As String) Implements IPlugin_Game.Process_PacketRecieved
        'DO SOMETHING HERE TO RECIEVED UDP PACKETS
        Input_Data = CType(DeSerializeString(Text), GenericOutput)
        With Input_Data
            Roll_Output = ._Roll
            Pitch_Output = ._Pitch
            Heave_Output = ._Heave
            Yaw_Output = ._Yaw
            Sway_Output = ._Sway
            Surge_Output = ._Surge
            Extra1_Output = ._Extra1
            Extra2_Output = ._Extra2
            Extra3_Output = ._Extra3
        End With
    End Sub

    'Used by GameManager to Patch a Game.
    Public Function PatchGame(ByVal MyPath As String, ByVal MyIp As String) As Boolean Implements IPlugin_Game.PatchGame
        'Change as Needed
        MsgBox("Patch Installed!", MsgBoxStyle.OkOnly, "Patching info")
        Return True
    End Function

    'Used by GameManager to UnPatch a Game.
    Public Sub UnPatchGame(MyPath As String) Implements IPlugin_Game.UnPatchGame
        'Change as Needed
        UnPatch(MyPath)
        MsgBox("Patch Uninstalled!", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    'Used by GameManager to UnPatch a Game.
    Private Sub UnPatch(MyPath As String)
        'Change as Needed
        MsgBox("Patch Uninstalled!", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    'Tells the User where to patch the game 
    Public Sub PatchPathInfo() Implements IPlugin_Game.PatchPathInfo
        'Tell the User where to patch the game 
        'Change as Needed
    End Sub

    'Used by GameManager to Validate a Path befors Patching.
    Public Function ValidatePatchPath(MyPath As String) As Boolean Implements IPlugin_Game.ValidatePatchPath
        'insert a simple validation of the patching path - let the user know he got it right
        'Change as Needed
    End Function


    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                                                 PLACE EXTRA NEEDED CODE/FUNCTIONS HERE                                                     ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Region "///// - EXTRA CODE/FUNCTIONS USED FOR THIS PLUGIN - /////"
    Public Declare Function ReadProcessMemory Lib "kernel32" Alias "ReadProcessMemory" (ByVal hProcess As Integer, ByVal lpBaseAddress As UInteger, ByVal lpBuffer() As Byte, ByVal nSize As Integer, ByRef lpNumberOfBytesWritten As Integer) As UInteger
    Public Declare Function OpenProcess Lib "kernel32" Alias "OpenProcess" (ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Integer, ByVal dwProcessId As Integer) As Integer
    Public Declare Function CloseHandle Lib "kernel32" Alias "CloseHandle" (ByVal hObject As Integer) As Integer
    Public Const To_Deg As Double = 180.0 / Math.PI

    'DeSerialize
    Public Function DeSerializeString(InputString As String) As Object
        On Error Resume Next
        Dim xml_serializer As New XmlSerializer(GetType(GenericOutput))
        Dim string_reader As New StringReader(InputString)
        Dim DeserializedOutput As GenericOutput = DirectCast(xml_serializer.Deserialize(string_reader), GenericOutput)
        string_reader.Close()
        Return DeserializedOutput
    End Function

    'Generic In/Output structure
    Public Structure GenericOutput
        Public _Roll As Double
        Public _Pitch As Double
        Public _Heave As Double
        Public _Yaw As Double
        Public _Sway As Double
        Public _Surge As Double
        Public _Extra1 As Double
        Public _Extra2 As Double
        Public _Extra3 As Double
    End Structure

    'memory hook function #1
    Public Function ReadSingle(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(3) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CUInt(dwAddress), buffer, 4, 0)
            Dim MySingle As Single = BitConverter.ToSingle(buffer, 0)
            Return MySingle.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

    'memory hook function #2
    Public Function ReadInt32(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(3) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CUInt(dwAddress), buffer, 4, 0)
            Dim MyInt32 As UInteger = BitConverter.ToUInt32(buffer, 0)
            Return MyInt32.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

    'memory hook function #3
    Public Function ReadDouble(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(7) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CUInt(dwAddress), buffer, 8, 0)
            Dim MyDouble As Double = BitConverter.ToDouble(buffer, 0)
            Return MyDouble.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function
#End Region


    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                                                        DO NOT EDIT BELOW HERE!!!                                                           ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Region "///// BUILT IN METHODS FOR SIMTOOLS - DO NOT CHANGE /////"
    'Output Dash Vars
    Public Dash_1_Output As String = ""
    Public Dash_2_Output As String = ""
    Public Dash_3_Output As String = ""
    Public Dash_4_Output As String = ""
    Public Dash_5_Output As String = ""
    Public Dash_6_Output As String = ""
    Public Dash_7_Output As String = ""
    Public Dash_8_Output As String = ""
    Public Dash_9_Output As String = ""
    Public Dash_10_Output As String = ""
    Public Dash_11_Output As String = ""
    Public Dash_12_Output As String = ""
    Public Dash_13_Output As String = ""
    Public Dash_14_Output As String = ""
    Public Dash_15_Output As String = ""
    Public Dash_16_Output As String = ""
    Public Dash_17_Output As String = ""
    Public Dash_18_Output As String = ""
    Public Dash_19_Output As String = ""
    Public Dash_20_Output As String = ""

    'Output Vars
    Public Roll_Output As Double = 0
    Public Pitch_Output As Double = 0
    Public Heave_Output As Double = 0
    Public Yaw_Output As Double = 0
    Public Sway_Output As Double = 0
    Public Surge_Output As Double = 0
    Public Extra1_Output As Double = 0
    Public Extra2_Output As Double = 0
    Public Extra3_Output As Double = 0

    'MemHook Vars
    Public Roll_MemHook As Double = 0
    Public Pitch_MemHook As Double = 0
    Public Heave_MemHook As Double = 0
    Public Yaw_MemHook As Double = 0
    Public Sway_MemHook As Double = 0
    Public Surge_MemHook As Double = 0
    Public Extra1_MemHook As Double = 0
    Public Extra2_MemHook As Double = 0
    Public Extra3_MemHook As Double = 0

    'MemMap Vars
    Public Roll_MemMap As Double = 0
    Public Pitch_MemMap As Double = 0
    Public Heave_MemMap As Double = 0
    Public Yaw_MemMap As Double = 0
    Public Sway_MemMap As Double = 0
    Public Surge_MemMap As Double = 0
    Public Extra1_MemMap As Double = 0
    Public Extra2_MemMap As Double = 0
    Public Extra3_MemMap As Double = 0

    'GameVibe Vars
    Public Vibe_1_Output As String = ""
    Public Vibe_2_Output As String = ""
    Public Vibe_3_Output As String = ""
    Public Vibe_4_Output As String = ""
    Public Vibe_5_Output As String = ""
    Public Vibe_6_Output As String = ""
    Public Vibe_7_Output As String = ""
    Public Vibe_8_Output As String = ""
    Public Vibe_9_Output As String = ""

    Public Function Get_PluginVersion() As String Implements IPlugin_Game.Get_PluginVersion
        Return System.Reflection.Assembly.GetExecutingAssembly.GetName.Version.ToString
    End Function

    Public Function GetDOFsUsed() As String Implements IPlugin_Game.GetDOFsUsed
        'Return DOF's Used (Roll,Pitch,Heave,Yaw,Sway,Surge)
        Return (_DOF_Support_Roll.ToString & "," & _DOF_Support_Pitch.ToString & "," & _DOF_Support_Heave.ToString & "," & _DOF_Support_Yaw.ToString & "," & _DOF_Support_Sway.ToString & "," & _DOF_Support_Surge.ToString & "," & _DOF_Support_Extra1.ToString & "," & _DOF_Support_Extra2.ToString & "," & _DOF_Support_Extra3.ToString)
    End Function

    Public Sub ResetDOFVars() Implements IPlugin_Game.ResetDOFVars
        Roll_Output = 0
        Pitch_Output = 0
        Heave_Output = 0
        Yaw_Output = 0
        Sway_Output = 0
        Surge_Output = 0
        Extra1_Output = 0
        Extra2_Output = 0
        Extra3_Output = 0
    End Sub

    Public Sub ResetMapVars() Implements IPlugin_Game.ResetMapVars
        Roll_MemMap = 0
        Pitch_MemMap = 0
        Heave_MemMap = 0
        Yaw_MemMap = 0
        Sway_MemMap = 0
        Surge_MemMap = 0
        Extra1_MemMap = 0
        Extra2_MemMap = 0
        Extra3_MemMap = 0
    End Sub

    Public Sub ResetHookVars() Implements IPlugin_Game.ResetHookVars
        Roll_MemHook = 0
        Pitch_MemHook = 0
        Heave_MemHook = 0
        Yaw_MemHook = 0
        Sway_MemHook = 0
        Surge_MemHook = 0
        Extra1_MemHook = 0
        Extra2_MemHook = 0
        Extra3_MemHook = 0
    End Sub

    Public Sub ResetDashVars() Implements IPlugin_Game.ResetDashVars
        Dash_1_Output = ""
        Dash_2_Output = ""
        Dash_3_Output = ""
        Dash_4_Output = ""
        Dash_5_Output = ""
        Dash_6_Output = ""
        Dash_7_Output = ""
        Dash_8_Output = ""
        Dash_9_Output = ""
        Dash_10_Output = ""
        Dash_11_Output = ""
        Dash_12_Output = ""
        Dash_13_Output = ""
        Dash_14_Output = ""
        Dash_15_Output = ""
        Dash_16_Output = ""
        Dash_17_Output = ""
        Dash_18_Output = ""
        Dash_19_Output = ""
        Dash_20_Output = ""
    End Sub

    Public Sub ResetVibeVars() Implements IPlugin_Game.ResetVibeVars
        Vibe_1_Output = ""
        Vibe_2_Output = ""
        Vibe_3_Output = ""
        Vibe_4_Output = ""
        Vibe_5_Output = ""
        Vibe_6_Output = ""
        Vibe_7_Output = ""
        Vibe_8_Output = ""
        Vibe_9_Output = ""
    End Sub

    Public ReadOnly Property PluginAuthorsName() As String Implements IPlugin_Game.PluginAuthorsName
        Get
            Return _PluginAuthorsName
        End Get
    End Property

    Public ReadOnly Property Name() As String Implements IPlugin_Game.GameName
        Get
            Return _GameName
        End Get
    End Property

    Public ReadOnly Property ProcessName() As String Implements IPlugin_Game.ProcessName
        Get
            Return _ProcessName
        End Get
    End Property

    Public ReadOnly Property Port() As String Implements IPlugin_Game.Port
        Get
            Return _Port
        End Get
    End Property

    Public ReadOnly Property Enable_MemoryMap() As Boolean Implements IPlugin_Game.Enable_MemoryMap
        Get
            Return _Enable_MemoryMap
        End Get
    End Property

    Public ReadOnly Property Enable_MemoryHook() As Boolean Implements IPlugin_Game.Enable_MemoryHook
        Get
            Return _Enable_MemoryHook
        End Get
    End Property

    Public ReadOnly Property RequiresPatchingPath() As Boolean Implements IPlugin_Game.RequiresPatchingPath
        Get
            Return _RequiresPatchingPath
        End Get
    End Property

    Public ReadOnly Property RequiresSecondCheck() As Boolean Implements IPlugin_Game.RequiresSecondCheck
        Get
            Return _RequiresSecondCheck
        End Get
    End Property

    Public ReadOnly Property Enable_DashBoard() As Boolean Implements IPlugin_Game.Enable_DashBoard
        Get
            Return _Enable_DashBoard
        End Get
    End Property

    Public ReadOnly Property Enable_GameVibe() As Boolean Implements IPlugin_Game.Enable_GameVibe
        Get
            Return _Enable_GameVibe
        End Get
    End Property

    Public Function Get_RollOutput() As Double Implements IPlugin_Game.Get_RollOutput
        Return Roll_Output
    End Function

    Public Function Get_PitchOutput() As Double Implements IPlugin_Game.Get_PitchOutput
        Return Pitch_Output
    End Function

    Public Function Get_HeaveOutput() As Double Implements IPlugin_Game.Get_HeaveOutput
        Return Heave_Output
    End Function

    Public Function Get_YawOutput() As Double Implements IPlugin_Game.Get_YawOutput
        Return Yaw_Output
    End Function

    Public Function Get_SwayOutput() As Double Implements IPlugin_Game.Get_SwayOutput
        Return Sway_Output
    End Function

    Public Function Get_SurgeOutput() As Double Implements IPlugin_Game.Get_SurgeOutput
        Return Surge_Output
    End Function

    Public Function Get_Extra1Output() As Double Implements IPlugin_Game.Get_Extra1Output
        Return Extra1_Output
    End Function

    Public Function Get_Extra2Output() As Double Implements IPlugin_Game.Get_Extra2Output
        Return Extra2_Output
    End Function

    Public Function Get_Extra3Output() As Double Implements IPlugin_Game.Get_Extra3Output
        Return Extra3_Output
    End Function

    Public Function Get_Dash_1_Output() As String Implements IPlugin_Game.Get_Dash1_Output
        Return Dash_1_Output
    End Function

    Public Function Get_Dash_2_Output() As String Implements IPlugin_Game.Get_Dash2_Output
        Return Dash_2_Output
    End Function

    Public Function Get_Dash_3_Output() As String Implements IPlugin_Game.Get_Dash3_Output
        Return Dash_3_Output
    End Function

    Public Function Get_Dash_4_Output() As String Implements IPlugin_Game.Get_Dash4_Output
        Return Dash_4_Output
    End Function

    Public Function Get_Dash_5_Output() As String Implements IPlugin_Game.Get_Dash5_Output
        Return Dash_5_Output
    End Function

    Public Function Get_Dash_6_Output() As String Implements IPlugin_Game.Get_Dash6_Output
        Return Dash_6_Output
    End Function

    Public Function Get_Dash_7_Output() As String Implements IPlugin_Game.Get_Dash7_Output
        Return Dash_7_Output
    End Function

    Public Function Get_Dash_8_Output() As String Implements IPlugin_Game.Get_Dash8_Output
        Return Dash_8_Output
    End Function

    Public Function Get_Dash_9_Output() As String Implements IPlugin_Game.Get_Dash9_Output
        Return Dash_9_Output
    End Function

    Public Function Get_Dash_10_Output() As String Implements IPlugin_Game.Get_Dash10_Output
        Return Dash_10_Output
    End Function

    Public Function Get_Dash_11_Output() As String Implements IPlugin_Game.Get_Dash11_Output
        Return Dash_11_Output
    End Function

    Public Function Get_Dash_12_Output() As String Implements IPlugin_Game.Get_Dash12_Output
        Return Dash_12_Output
    End Function

    Public Function Get_Dash_13_Output() As String Implements IPlugin_Game.Get_Dash13_Output
        Return Dash_13_Output
    End Function

    Public Function Get_Dash_14_Output() As String Implements IPlugin_Game.Get_Dash14_Output
        Return Dash_14_Output
    End Function

    Public Function Get_Dash_15_Output() As String Implements IPlugin_Game.Get_Dash15_Output
        Return Dash_15_Output
    End Function

    Public Function Get_Dash_16_Output() As String Implements IPlugin_Game.Get_Dash16_Output
        Return Dash_16_Output
    End Function

    Public Function Get_Dash_17_Output() As String Implements IPlugin_Game.Get_Dash17_Output
        Return Dash_17_Output
    End Function

    Public Function Get_Dash_18_Output() As String Implements IPlugin_Game.Get_Dash18_Output
        Return Dash_18_Output
    End Function

    Public Function Get_Dash_19_Output() As String Implements IPlugin_Game.Get_Dash19_Output
        Return Dash_19_Output
    End Function

    Public Function Get_Dash_20_Output() As String Implements IPlugin_Game.Get_Dash20_Output
        Return Dash_20_Output
    End Function

    Public Function Get_RollMemHook() As Double Implements IPlugin_Game.Get_RollMemHook
        Return Roll_MemHook
    End Function

    Public Function Get_PitchMemHook() As Double Implements IPlugin_Game.Get_PitchMemHook
        Return Pitch_MemHook
    End Function

    Public Function Get_HeaveMemHook() As Double Implements IPlugin_Game.Get_HeaveMemHook
        Return Heave_MemHook
    End Function

    Public Function Get_YawMemHook() As Double Implements IPlugin_Game.Get_YawMemHook
        Return Yaw_MemHook
    End Function

    Public Function Get_SwayMemHook() As Double Implements IPlugin_Game.Get_SwayMemHook
        Return Sway_MemHook
    End Function

    Public Function Get_SurgeMemHook() As Double Implements IPlugin_Game.Get_SurgeMemHook
        Return Surge_MemHook
    End Function

    Public Function Get_Extra1MemHook() As Double Implements IPlugin_Game.Get_Extra1MemHook
        Return Extra1_MemHook
    End Function

    Public Function Get_Extra2MemHook() As Double Implements IPlugin_Game.Get_Extra2MemHook
        Return Extra2_MemHook
    End Function

    Public Function Get_Extra3MemHook() As Double Implements IPlugin_Game.Get_Extra3MemHook
        Return Extra3_MemHook
    End Function

    Public Function Get_RollMemMap() As Double Implements IPlugin_Game.Get_RollMemMap
        Return Roll_MemMap
    End Function

    Public Function Get_PitchMemMap() As Double Implements IPlugin_Game.Get_PitchMemMap
        Return Pitch_MemMap
    End Function

    Public Function Get_HeaveMemMap() As Double Implements IPlugin_Game.Get_HeaveMemMap
        Return Heave_MemMap
    End Function

    Public Function Get_YawMemMap() As Double Implements IPlugin_Game.Get_YawMemMap
        Return Yaw_MemMap
    End Function

    Public Function Get_SwayMemMap() As Double Implements IPlugin_Game.Get_SwayMemMap
        Return Sway_MemMap
    End Function

    Public Function Get_SurgeMemMap() As Double Implements IPlugin_Game.Get_SurgeMemMap
        Return Surge_MemMap
    End Function

    Public Function Get_Extra1MemMap() As Double Implements IPlugin_Game.Get_Extra1MemMap
        Return Extra1_MemMap
    End Function

    Public Function Get_Extra2MemMap() As Double Implements IPlugin_Game.Get_Extra2MemMap
        Return Extra2_MemMap
    End Function

    Public Function Get_Extra3MemMap() As Double Implements IPlugin_Game.Get_Extra3MemMap
        Return Extra3_MemMap
    End Function

    Public Function Get_Vibe1_Output() As String Implements IPlugin_Game.Get_Vibe1_Output
        Return Vibe_1_Output
    End Function

    Public Function Get_Vibe2_Output() As String Implements IPlugin_Game.Get_Vibe2_Output
        Return Vibe_2_Output
    End Function

    Public Function Get_Vibe3_Output() As String Implements IPlugin_Game.Get_Vibe3_Output
        Return Vibe_3_Output
    End Function

    Public Function Get_Vibe4_Output() As String Implements IPlugin_Game.Get_Vibe4_Output
        Return Vibe_4_Output
    End Function

    Public Function Get_Vibe5_Output() As String Implements IPlugin_Game.Get_Vibe5_Output
        Return Vibe_5_Output
    End Function

    Public Function Get_Vibe6_Output() As String Implements IPlugin_Game.Get_Vibe6_Output
        Return Vibe_6_Output
    End Function

    Public Function Get_Vibe7_Output() As String Implements IPlugin_Game.Get_Vibe7_Output
        Return Vibe_7_Output
    End Function

    Public Function Get_Vibe8_Output() As String Implements IPlugin_Game.Get_Vibe8_Output
        Return Vibe_8_Output
    End Function

    Public Function Get_Vibe9_Output() As String Implements IPlugin_Game.Get_Vibe9_Output
        Return Vibe_9_Output
    End Function

    Public ReadOnly Property PluginOptions() As String Implements IPlugin_Game.PluginOptions
        Get
            Return _PluginOptions
        End Get
    End Property
#End Region
End Class